---
title: Anotácia pomenovaných entít
published: true
process:
  twig: true
cache_enable: false
taxonomy:
  author: Daniel Hladek
  categories: [project]
  tags: [ner,annotation]
forms:
  ner1:
    name: ner1
    fields:
    - name: name
      label: Login
      placeholder: Váš e-mail
      autofocus: on
      autocomplete: on
      type: email
      validate:
        required: true
        message: Musíte zadať platný e-mail aby sa započítala anotácia
    buttons:
    - type: submit
      value: Začni anotovať
    process:
    - redirect: "https://skner.tukekemt.xyz/?session={{ form.value.name }}"
---


# Anotácia pomenovaných entít

Pomôžte nám pri vedeckom výskume tým, že naučíte stroj rozpoznávať vlastné podstatné mená.
Učenie prebieha tak, že v texte ukážete ktoré slová patria názvom osôb, miest, organizácií alebo vecí.
Účasť v tomto experimente Vám pomôže vylepšiť Vaše študijné výsledky a vyhrať aj televízny otázkový kvíz "Tisícionár".

## Návod pre anotátorov


Vašou úlohou bude v texte vyznačiť vlastné podstatné mená.
Vlastné podstatné meno sa v slovenskom jazyku spravidla začína veľkým písmenom, ale môže obsahovať aj ďalšie slová písané malým písmenom. 
Ak vlastné podstatné meno v sebe obsahuje iný názov, napr. Nové Mesto nad Váhom, anotujte ho ako jeden celok.

- PER: mená osôb
- LOC: geografické názvy
- ORG: názvy organizácii
- MISC: iné názvy, napr. názvy produktov.

V texte narazíte aj na slová, ktoré síce pomenúvajú geografickú oblasť, avšak nejedná sa o vlastné podstatné mená (napr. britská kolónia, londýnsky šerif...). Takéto slová nepovažujeme za pomenované entity a preto Vás prosíme, aby ste ich neoznačovali.

V prípade, že v texte sa nenachádzajú žiadne anotácie, tento článok je platný, a teda zvoľte možnosť Accept.

V prípade, že text sa skladá iba z jedného, resp. niekoľkých slov, ktoré sami o sebe nenesú žiaden význam, tento článok je neplatný, a teda zvoľte možnosť Reject.  

## Anotačné dávky

Do formulára napíšte Váš e-mail aby bolo možné rozpoznať, kto vykonal anotáciu. 

Počas anotácie môžete pre zjednodušenie práce využívať klávesové skratky: 
- 1,2,3,4 - prepínanie medzi entitami
- klávesa "a" - Accept
- klávesa "x" - Reject
- klávesa "space" - Ignore
- klávesa "backspace" alebo "del" - Undo

Po anotovaní nezabudnite svojú prácu uložiť (ikona vľavo hore, alebo "Ctrl + s").

### Pokusná anotačná dávka

Dávka je zameraná na zber spätnej väzby od anotátorov na zlepšenie rozhrania a anotačného procesu.

{% include "forms/form.html.twig" with { form: forms('ner1') } %}
